import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart';
import 'iroute.dart';

class IRouteMaster extends RouterDelegate<String>
    with ChangeNotifier, PopNavigatorRouterDelegateMixin {
  final GlobalKey<NavigatorState>? navigatorKey;

  late Widget child;
  String url = '/';
  IRouteMaster({required this.child}) : navigatorKey = GlobalKey();

  IRoute? _nested;
  set nested(value) {
    this._nested = value;
  }

  static IRouteMaster of(BuildContext context) {
    final delegate = Router.of(context).routerDelegate;
    assert(delegate is IRouteMaster, 'Delegate type must match');
    return delegate as IRouteMaster;
  }

  @override
  Widget build(BuildContext context) {
    return Navigator(
        key: navigatorKey,
        pages: [
          MaterialPage(
            child: child,
          ),
        ],
        onPopPage: (route, result) {
          //assert(false);
          return false;
        });
  }

  //detail.pages.last?
  String get currentConfiguration {
    return url;
  }

  set currentConfiguration(String value) {
    url = value;
    notifyListeners();
  }

  @override
  Future<void> setNewRoutePath(String path) async {
    if (path == url) return SynchronousFuture(null);
    if (this._nested != null) _nested!.setNewRoutePath(path);

    // url = path;
    // notifyListeners();
    return SynchronousFuture(null);
  }
}
