class UrlParser {
  static const dynamicParams = {':ipage'}; //ipage是动态参数
  static String getPattern(url) {
    String pattern =
        url.replaceAllMapped(RegExp('(:[sid][^=]+)(=[^/]+)'), (match) {
      //print(
      //    'matched:${match.groupCount},group0:${match.group(0)},group1:${match.group(1)},group2:${match.group(2)}');

      if (dynamicParams.contains(match.group(1)))
        return ''; //如果参数名是动态参数，比如:ipage，则不加入pattern
      return '${match.group(1)}';
    });
    return pattern;
  }

  static Map<String, dynamic> getParam(url) {
    //var url = '/book/:iid=1/:iid1=3';
    //url本身不改变，而是返回新串

    //支持'/:iid=3/:iid1=2'这样，每节一个参数
    //var regExp = RegExp('(/:[sid][^=]+)(=[^/]+)');

    //改为支持‘/:iid=3:iid1=2'这样每节两个参数
    var regExp = RegExp('(:[sid][^=]+)(=[^/^:]+)');

    var result = regExp.allMatches(url);
    Map<String, dynamic> args = Map<String, dynamic>();
    for (RegExpMatch match in result) {
      //每节一个参数：
      //var argName = match.group(1)!.substring(3);
      //var argType = match.group(1)![2];

      //每节多个参数
      var argName = match.group(1)!.substring(2);
      var argType = match.group(1)![1];

      var argValue = match.group(2)!.substring(1); //去掉等号

      dynamic value;

      if (argType == 'i') value = int.tryParse(argValue);
      if (argType == 'd') value = double.tryParse(argValue);
      if (argType == 's') value = argValue;
      args[argName] = value;
      //print('args[$argName]=${args[argName]}');
    }
    return args;
  }

  //类似'/:iid=1_3这样，去掉_3
  static removeOrder(String url) {
    //这个正则表达式应该安全，它必须是在尾部，且以_开头后面没有/

    //r'(_[^/^_]+)$'
    //$表示包括结束，也就是匹配在字符串最尾部
    //_表示以_开头
    //[^/^_]+ 表示不能有/和_两个字符，+表示多个字符。所以/_book_3只有一个匹配_3,book前的_到结尾之间还有_
    var result = url.replaceAllMapped(RegExp(r'(_[^/^_]+)$'), (match) {
      //print('matched:${match.groupCount},group0:${match.group(0)}}');
      return '';
    });
    return result;
  }
}
